function utf16to8(d) {
    var a, b, e, c;
    a = "";
    e = d.length;
    for (b = 0; b < e; b++)c = d.charCodeAt(b), 1 <= c && 127 >= c ? a += d.charAt(b) : (2047 < c ? (a += String.fromCharCode(224 | c >> 12 & 15), a += String.fromCharCode(128 | c >> 6 & 63)) : a += String.fromCharCode(192 | c >> 6 & 31), a += String.fromCharCode(128 | c >> 0 & 63));
    return a
}
function utf8to16(d) {
    var a, b, e, c, f, g;
    a = "";
    e = d.length;
    for (b = 0; b < e;)switch (c = d.charCodeAt(b++), c >> 4) {
        case 0:
        case 1:
        case 2:
        case 3:
        case 4:
        case 5:
        case 6:
        case 7:
            a += d.charAt(b - 1);
            break;
        case 12:
        case 13:
            f = d.charCodeAt(b++);
            a += String.fromCharCode((c & 31) << 6 | f & 63);
            break;
        case 14:
            f = d.charCodeAt(b++), g = d.charCodeAt(b++), a += String.fromCharCode((c & 15) << 12 | (f & 63) << 6 | (g & 63) << 0)
    }
    return a
}
var base64EncodeChars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/", base64DecodeChars = [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62, -1, -1, -1, 63, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, -1, -1, -1, -1, -1, -1, -1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, -1, -1, -1, -1, -1, -1, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, -1, -1, -1, -1, -1];
function base64encode(d) {
    var a, b, e, c, f, g;
    e = d.length;
    b = 0;
    for (a = ""; b < e;) {
        c = d.charCodeAt(b++) & 255;
        if (b == e) {
            a += base64EncodeChars.charAt(c >> 2);
            a += base64EncodeChars.charAt((c & 3) << 4);
            a += "==";
            break
        }
        f = d.charCodeAt(b++);
        if (b == e) {
            a += base64EncodeChars.charAt(c >> 2);
            a += base64EncodeChars.charAt((c & 3) << 4 | (f & 240) >> 4);
            a += base64EncodeChars.charAt((f & 15) << 2);
            a += "=";
            break
        }
        g = d.charCodeAt(b++);
        a += base64EncodeChars.charAt(c >> 2);
        a += base64EncodeChars.charAt((c & 3) << 4 | (f & 240) >> 4);
        a += base64EncodeChars.charAt((f & 15) << 2 | (g & 192) >> 6);
        a += base64EncodeChars.charAt(g & 63)
    }
    return a
}
function base64decode(d) {
    var a, b, e, c, f;
    c = d.length;
    e = 0;
    for (f = ""; e < c;) {
        do a = base64DecodeChars[d.charCodeAt(e++) & 255]; while (e < c && -1 == a);
        if (-1 == a)break;
        do b = base64DecodeChars[d.charCodeAt(e++) & 255]; while (e < c && -1 == b);
        if (-1 == b)break;
        f += String.fromCharCode(a << 2 | (b & 48) >> 4);
        do {
            a = d.charCodeAt(e++) & 255;
            if (61 == a)return f;
            a = base64DecodeChars[a]
        } while (e < c && -1 == a);
        if (-1 == a)break;
        f += String.fromCharCode((b & 15) << 4 | (a & 60) >> 2);
        do {
            b = d.charCodeAt(e++) & 255;
            if (61 == b)return f;
            b = base64DecodeChars[b]
        } while (e < c && -1 == b);
        if (-1 == b)break;
        f += String.fromCharCode((a & 3) << 6 | b)
    }
    return f
}
function decode64(d) {
    return utf8to16(base64decode(d))
}
function encode64(d) {
    return base64encode(utf16to8(d))
}
(function (n) {
    function l(a) {
        a ? (k[0] = k[16] = k[1] = k[2] = k[3] = k[4] = k[5] = k[6] = k[7] = k[8] = k[9] = k[10] = k[11] = k[12] = k[13] = k[14] = k[15] = 0, this.blocks = k, this.buffer8 = r) : p ? (a = new ArrayBuffer(68), this.buffer8 = new Uint8Array(a), this.blocks = new Uint32Array(a)) : this.blocks = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
        this.h0 = this.h1 = this.h2 = this.h3 = this.start = this.bytes = 0;
        this.finalized = this.hashed = !1;
        this.first = !0
    }

    var t = "object" == typeof process && process.versions && process.versions.node;
    t && (n = global);
    var x = !n.JS_MD5_TEST && "object" == typeof module && module.exports, y = "function" == typeof define && define.amd, p = !n.JS_MD5_TEST && "undefined" != typeof ArrayBuffer, g = "0123456789abcdef".split(""), z = [128, 32768, 8388608, -2147483648], m = [0, 8, 16, 24], u = ["hex", "array", "digest", "buffer", "arrayBuffer"], k = [], r;
    if (p) {
        var v = new ArrayBuffer(68);
        r = new Uint8Array(v);
        k = new Uint32Array(v)
    }
    var w = function (a) {
        return function (d) {
            return (new l(!0)).update(d)[a]()
        }
    }, A = function (a) {
        var d, b;
        try {
            if (n.JS_MD5_TEST)throw"JS_MD5_TEST";
            d = require("crypto");
            b = require("buffer").Buffer
        } catch (c) {
            return console.log(c), a
        }
        return function (c) {
            if ("string" == typeof c)return d.createHash("md5").update(c, "utf8").digest("hex");
            if (c.constructor == ArrayBuffer) c = new Uint8Array(c); else if (void 0 === c.length)return a(c);
            return d.createHash("md5").update(new b(c)).digest("hex")
        }
    }
    l.prototype.update = function (a) {
        if (!this.finalized) {
            var d = "string" != typeof a;
            d && a.constructor == n.ArrayBuffer && (a = new Uint8Array(a));
            for (var b, c = 0, f, e = a.length || 0, h = this.blocks, g = this.buffer8; c < e;) {
                this.hashed && (this.hashed = !1, h[0] = h[16], h[16] = h[1] = h[2] = h[3] = h[4] = h[5] = h[6] = h[7] = h[8] = h[9] = h[10] = h[11] = h[12] = h[13] = h[14] = h[15] = 0);
                if (d)if (p)for (f = this.start; c < e && 64 > f; ++c)g[f++] = a[c]; else for (f = this.start; c < e && 64 > f; ++c)h[f >> 2] |= a[c] << m[f++ & 3]; else if (p)for (f = this.start; c < e && 64 > f; ++c)b = a.charCodeAt(c), 128 > b ? g[f++] = b : (2048 > b ? g[f++] = 192 | b >> 6 : (55296 > b || 57344 <= b ? g[f++] = 224 | b >> 12 : (b = 65536 + ((b & 1023) << 10 | a.charCodeAt(++c) & 1023), g[f++] = 240 | b >> 18, g[f++] = 128 | b >> 12 & 63), g[f++] = 128 | b >> 6 & 63), g[f++] = 128 | b & 63); else for (f = this.start; c < e && 64 > f; ++c)b = a.charCodeAt(c), 128 > b ? h[f >> 2] |= b << m[f++ & 3] : (2048 > b ? h[f >> 2] |= (192 | b >> 6) << m[f++ & 3] : (55296 > b || 57344 <= b ? h[f >> 2] |= (224 | b >> 12) << m[f++ & 3] : (b = 65536 + ((b & 1023) << 10 | a.charCodeAt(++c) & 1023), h[f >> 2] |= (240 | b >> 18) << m[f++ & 3], h[f >> 2] |= (128 | b >> 12 & 63) << m[f++ & 3]), h[f >> 2] |= (128 | b >> 6 & 63) << m[f++ & 3]), h[f >> 2] |= (128 | b & 63) << m[f++ & 3]);
                this.lastByteIndex = f;
                this.bytes += f - this.start;
                64 <= f ? (this.start = f - 64, this.hash(), this.hashed = !0) : this.start = f
            }
            ;
            return this
        }
    }
    l.prototype.finalize = function () {
        if (!this.finalized) {
            this.finalized = !0;
            var a = this.blocks, d = this.lastByteIndex;
            a[d >> 2] |= z[d & 3];
            56 <= d && (this.hashed || this.hash(), a[0] = a[16], a[16] = a[1] = a[2] = a[3] = a[4] = a[5] = a[6] = a[7] = a[8] = a[9] = a[10] = a[11] = a[12] = a[13] = a[14] = a[15] = 0);
            a[14] = this.bytes << 3;
            this.hash()
        }
    }
    l.prototype.hash = function () {
        var a, d, b, c, f, e = this.blocks;
        this.first ? (a = e[0] - 680876937, a = (a << 7 | a >>> 25) - 271733879 << 0, c = (-1732584194 ^ a & 2004318071) + e[1] - 117830708, c = (c << 12 | c >>> 20) + a << 0, b = (-271733879 ^ c & (a ^ -271733879)) + e[2] - 1126478375, b = (b << 17 | b >>> 15) + c << 0, d = (a ^ b & (c ^ a)) + e[3] - 1316259209) : (a = this.h0, d = this.h1, b = this.h2, c = this.h3, a += (c ^ d & (b ^ c)) + e[0] - 680876936, a = (a << 7 | a >>> 25) + d << 0, c += (b ^ a & (d ^ b)) + e[1] - 389564586, c = (c << 12 | c >>> 20) + a << 0, b += (d ^ c & (a ^ d)) + e[2] + 606105819, b = (b << 17 | b >>> 15) + c << 0, d += (a ^ b & (c ^ a)) + e[3] - 1044525330);
        d = (d << 22 | d >>> 10) + b << 0;
        a += (c ^ d & (b ^ c)) + e[4] - 176418897;
        a = (a << 7 | a >>> 25) + d << 0;
        c += (b ^ a & (d ^ b)) + e[5] + 1200080426;
        c = (c << 12 | c >>> 20) + a << 0;
        b += (d ^ c & (a ^ d)) + e[6] - 1473231341;
        b = (b << 17 | b >>> 15) + c << 0;
        d += (a ^ b & (c ^ a)) + e[7] - 45705983;
        d = (d << 22 | d >>> 10) + b << 0;
        a += (c ^ d & (b ^ c)) + e[8] + 1770035416;
        a = (a << 7 | a >>> 25) + d << 0;
        c += (b ^ a & (d ^ b)) + e[9] - 1958414417;
        c = (c << 12 | c >>> 20) + a << 0;
        b += (d ^ c & (a ^ d)) + e[10] - 42063;
        b = (b << 17 | b >>> 15) + c << 0;
        d += (a ^ b & (c ^ a)) + e[11] - 1990404162;
        d = (d << 22 | d >>> 10) + b << 0;
        a += (c ^ d & (b ^ c)) + e[12] + 1804603682;
        a = (a << 7 | a >>> 25) + d << 0;
        c += (b ^ a & (d ^ b)) + e[13] - 40341101;
        c = (c << 12 | c >>> 20) + a << 0;
        b += (d ^ c & (a ^ d)) + e[14] - 1502002290;
        b = (b << 17 | b >>> 15) + c << 0;
        d += (a ^ b & (c ^ a)) + e[15] + 1236535329;
        d = (d << 22 | d >>> 10) + b << 0;
        a += (b ^ c & (d ^ b)) + e[1] - 165796510;
        a = (a << 5 | a >>> 27) + d << 0;
        c += (d ^ b & (a ^ d)) + e[6] - 1069501632;
        c = (c << 9 | c >>> 23) + a << 0;
        b += (a ^ d & (c ^ a)) + e[11] + 643717713;
        b = (b << 14 | b >>> 18) + c << 0;
        d += (c ^ a & (b ^ c)) + e[0] - 373897302;
        d = (d << 20 | d >>> 12) + b << 0;
        a += (b ^ c & (d ^ b)) + e[5] - 701558691;
        a = (a << 5 | a >>> 27) + d << 0;
        c += (d ^ b & (a ^ d)) + e[10] + 38016083;
        c = (c << 9 | c >>> 23) + a << 0;
        b += (a ^ d & (c ^ a)) + e[15] - 660478335;
        b = (b << 14 | b >>> 18) + c << 0;
        d += (c ^ a & (b ^ c)) + e[4] - 405537848;
        d = (d << 20 | d >>> 12) + b << 0;
        a += (b ^ c & (d ^ b)) + e[9] + 568446438;
        a = (a << 5 | a >>> 27) + d << 0;
        c += (d ^ b & (a ^ d)) + e[14] - 1019803690;
        c = (c << 9 | c >>> 23) + a << 0;
        b += (a ^ d & (c ^ a)) + e[3] - 187363961;
        b = (b << 14 | b >>> 18) + c << 0;
        d += (c ^ a & (b ^ c)) + e[8] + 1163531501;
        d = (d << 20 | d >>> 12) + b << 0;
        a += (b ^ c & (d ^ b)) + e[13] - 1444681467;
        a = (a << 5 | a >>> 27) + d << 0;
        c += (d ^ b & (a ^ d)) + e[2] - 51403784;
        c = (c << 9 | c >>> 23) + a << 0;
        b += (a ^ d & (c ^ a)) + e[7] + 1735328473;
        b = (b << 14 | b >>> 18) + c << 0;
        d += (c ^ a & (b ^ c)) + e[12] - 1926607734;
        d = (d << 20 | d >>> 12) + b << 0;
        f = d ^ b;
        a += (f ^ c) + e[5] - 378558;
        a = (a << 4 | a >>> 28) + d << 0;
        c += (f ^ a) + e[8] - 2022574463;
        c = (c << 11 | c >>> 21) + a << 0;
        f = c ^ a;
        b += (f ^ d) + e[11] + 1839030562;
        b = (b << 16 | b >>> 16) + c << 0;
        d += (f ^ b) + e[14] - 35309556;
        d = (d << 23 | d >>> 9) + b << 0;
        f = d ^ b;
        a += (f ^ c) + e[1] - 1530992060;
        a = (a << 4 | a >>> 28) + d << 0;
        c += (f ^ a) + e[4] + 1272893353;
        c = (c << 11 | c >>> 21) + a << 0;
        f = c ^ a;
        b += (f ^ d) + e[7] - 155497632;
        b = (b << 16 | b >>> 16) + c << 0;
        d += (f ^ b) + e[10] - 1094730640;
        d = (d << 23 | d >>> 9) + b << 0;
        f = d ^ b;
        a += (f ^ c) + e[13] + 681279174;
        a = (a << 4 | a >>> 28) + d << 0;
        c += (f ^ a) + e[0] - 358537222;
        c = (c << 11 | c >>> 21) + a << 0;
        f = c ^ a;
        b += (f ^ d) + e[3] - 722521979;
        b = (b << 16 | b >>> 16) + c << 0;
        d += (f ^ b) + e[6] + 76029189;
        d = (d << 23 | d >>> 9) + b << 0;
        f = d ^ b;
        a += (f ^ c) + e[9] - 640364487;
        a = (a << 4 | a >>> 28) + d << 0;
        c += (f ^ a) + e[12] - 421815835;
        c = (c << 11 | c >>> 21) + a << 0;
        f = c ^ a;
        b += (f ^ d) + e[15] + 530742520;
        b = (b << 16 | b >>> 16) + c << 0;
        d += (f ^ b) + e[2] - 995338651;
        d = (d << 23 | d >>> 9) + b << 0;
        a += (b ^ (d | ~c)) + e[0] - 198630844;
        a = (a << 6 | a >>> 26) + d << 0;
        c += (d ^ (a | ~b)) + e[7] + 1126891415;
        c = (c << 10 | c >>> 22) + a << 0;
        b += (a ^ (c | ~d)) + e[14] - 1416354905;
        b = (b << 15 | b >>> 17) + c << 0;
        d += (c ^ (b | ~a)) + e[5] - 57434055;
        d = (d << 21 | d >>> 11) + b << 0;
        a += (b ^ (d | ~c)) + e[12] + 1700485571;
        a = (a << 6 | a >>> 26) + d << 0;
        c += (d ^ (a | ~b)) + e[3] - 1894986606;
        c = (c << 10 | c >>> 22) + a << 0;
        b += (a ^ (c | ~d)) + e[10] - 1051523;
        b = (b << 15 | b >>> 17) + c << 0;
        d += (c ^ (b | ~a)) + e[1] - 2054922799;
        d = (d << 21 | d >>> 11) + b << 0;
        a += (b ^ (d | ~c)) + e[8] + 1873313359;
        a = (a << 6 | a >>> 26) + d << 0;
        c += (d ^ (a | ~b)) + e[15] - 30611744;
        c = (c << 10 | c >>> 22) + a << 0;
        b += (a ^ (c | ~d)) + e[6] - 1560198380;
        b = (b << 15 | b >>> 17) + c << 0;
        d += (c ^ (b | ~a)) + e[13] + 1309151649;
        d = (d << 21 | d >>> 11) + b << 0;
        a += (b ^ (d | ~c)) + e[4] - 145523070;
        a = (a << 6 | a >>> 26) + d << 0;
        c += (d ^ (a | ~b)) + e[11] - 1120210379;
        c = (c << 10 | c >>> 22) + a << 0;
        b += (a ^ (c | ~d)) + e[2] + 718787259;
        b = (b << 15 | b >>> 17) + c << 0;
        d += (c ^ (b | ~a)) + e[9] - 343485551;
        d = (d << 21 | d >>> 11) + b << 0;
        this.first ? (this.h0 = a + 1732584193 << 0, this.h1 = d - 271733879 << 0, this.h2 = b - 1732584194 << 0, this.h3 = c + 271733878 << 0, this.first = !1) : (this.h0 = this.h0 + a << 0, this.h1 = this.h1 + d << 0, this.h2 = this.h2 + b << 0, this.h3 = this.h3 + c << 0)
    }
    l.prototype.hex = function () {
        this.finalize();
        var a = this.h0, d = this.h1, b = this.h2, c = this.h3;
        return g[a >> 4 & 15] + g[a & 15] + g[a >> 12 & 15] + g[a >> 8 & 15] + g[a >> 20 & 15] + g[a >> 16 & 15] + g[a >> 28 & 15] + g[a >> 24 & 15] + g[d >> 4 & 15] + g[d & 15] + g[d >> 12 & 15] + g[d >> 8 & 15] + g[d >> 20 & 15] + g[d >> 16 & 15] + g[d >> 28 & 15] + g[d >> 24 & 15] + g[b >> 4 & 15] + g[b & 15] + g[b >> 12 & 15] + g[b >> 8 & 15] + g[b >> 20 & 15] + g[b >> 16 & 15] + g[b >> 28 & 15] + g[b >> 24 & 15] + g[c >> 4 & 15] + g[c & 15] + g[c >> 12 & 15] + g[c >> 8 & 15] + g[c >> 20 & 15] + g[c >> 16 & 15] + g[c >> 28 & 15] + g[c >> 24 & 15]
    }
    l.prototype.toString = l.prototype.hex;
    l.prototype.digest = function () {
        this.finalize();
        var a = this.h0, d = this.h1, b = this.h2, c = this.h3;
        return [a & 255, a >> 8 & 255, a >> 16 & 255, a >> 24 & 255, d & 255, d >> 8 & 255, d >> 16 & 255, d >> 24 & 255, b & 255, b >> 8 & 255, b >> 16 & 255, b >> 24 & 255, c & 255, c >> 8 & 255, c >> 16 & 255, c >> 24 & 255]
    }
    l.prototype.array = l.prototype.digest;
    l.prototype.arrayBuffer = function () {
        this.finalize();
        var a = new ArrayBuffer(16), d = new Uint32Array(a);
        d[0] = this.h0;
        d[1] = this.h1;
        d[2] = this.h2;
        d[3] = this.h3;
        return a
    }
    l.prototype.buffer = l.prototype.arrayBuffer;
    var q = function () {
        var a = w("hex");
        t && (a = A(a));
        a.create = function () {
            return new l
        }
        a.update = function (b) {
            return a.create().update(b)
        }
        for (var d = 0; d < u.length; ++d) {
            var b = u[d];
            a[b] = w(b)
        }
        return a
    }();
    x ? module.exports = q : (n.md5 = q, y && define(function () {
        return q
    }))
})(this);
var cc_crypt = {
    encode: function (a) {
        var b = (new Date).getTime() + 6E5, b = cc_crypt.rand_str("r", 256) + b, c = md5(b).toString().toLowerCase();
        a = encode64(a);
        a = cc_crypt.cc_xor(a, c);
        b = cc_crypt.cc_xor(b, a);
        a += b;
        b = "";
        for (c = 0; c < a.length; c += 1) {
            b = b + a[c].charCodeAt().toString() + "|"
        }
        return encode64(b)
    }, decode: function (a) {
        a = decode64(a);
        var b = a.lastIndexOf("|");
        a = a.substr(0, b);
        a = a.split("|");
        t = "";
        for (b = 0; b < a.length; b += 1) {
            t += String.fromCharCode(a[b]).toString()
        }
        a = t;
        var c = a.length, b = a.substr(c - 269, 269), c = a.substr(0, c - 269);
        a = cc_crypt.cc_xor(b, a);
        time = a.substr(a.length - 13, 13);
        if (0 > parseInt(time) - parseInt((new Date).getTime())) {
            alert("time expire")
        } else {
            return a = md5(cc_crypt.cc_xor(b, c)).toLowerCase(), a = cc_crypt.cc_xor(c, a), decode64(a)
        }
    }, rand_str: function (a, b) {
        a || (a = "n");
        isNaN(b) && (b = 6);
        var c, d;
        switch (a) {
            case"n":
                c = "1234567890";
                d = 9;
                break;
            case"s":
                c = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLOMNOPQRSTUVWXYZ";
                d = 52;
                break;
            case"r":
                c = "1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLOMNOPQRSTUVWXYZ";
                d = 62;
                break;
            default:
                c = "1234567890", d = 9
        }
        for (var e = "", f = 0; f < b; f += 1) {
            e += c[cc_crypt.rand(0, d)]
        }
        return e
    }, rand: function (a, b) {
        var c = b - a, d = Math.random();
        return 0 == Math.round(d * c) ? a + 1 : Math.round(d * b) == b ? b - 1 : a + Math.round(d * c) - 1
    }, cc_xor: function (a, b) {
        for (var c = a.length, d = b.length, e = "", f = 0; f < c; f += 1) {
            var g = a.substr(f, 1).charCodeAt(), h = b.substr(f % d, 1).charCodeAt(), e = e + String.fromCharCode(g ^ h)
        }
        return e
    }
}